<template>
  <mt-connexion-template>
    <template v-slot:partie-droite>
      <section v-if="!errorToken">
        <form @submit.prevent="valider()">
          <h2>Réinitialisation de mot de passe</h2>
          <b-field label="Mot de passe">
            <b-input
              key="user-password"
              v-model="user.password"
              placeholder="Mot de passe"
              type="password"
              password-reveal
              required
              class="input-login"
            />
          </b-field>

          <b-field label="confirmez le Mot de passe">
            <b-input
              key="user-password-confirmation"
              v-model="user.passwordconfirmation"
              placeholder="Mot de passe"
              type="password"
              password-reveal
              required
              class="input-login"
            />
            <div class="control">
              <p v-if="erreur" class="help is-danger">{{ erreur }}</p>
            </div>
          </b-field>

          <mt-password-security-meter :password="user.password" :rules="rules"></mt-password-security-meter>

          <div class="columns">
            <b-button
              class="mt-button is-size-7 column is-narrow"
              type="is-primary"
              native-type="submit"
              :disabled="disablePage"
            >
              Changer votre mot de passe
            </b-button>
          </div>
        </form>
      </section>
      <section v-if="errorToken">
        <h2>Cette demande a expiré :'(</h2>

        <p>Vous n'aviez que <b>24h</b> pour changer votre mot de passe.</p>
        <p>Vous pouvez renouveller votre demande sur la page d'accueil.</p>
        <br />
        <p class="has-text-left">
          À bientôt, <br />
          L’équipe METIIS.
        </p>

        <nuxt-link :to="{ name: 'index' }" class="button mt-button is-size-7 is-primary"
          >Retour à la page d'accueil</nuxt-link
        >
      </section>
      <mt-modal-ok
        :ouvert.sync="ouvert"
        titre="Votre nouveau mot de passe a bien été pris en compte."
        button="Retour à l’accueil"
        class-button=""
        @action="retourAccueil"
      >
        Connectez-vous pour l'essayer.
      </mt-modal-ok>
    </template>
  </mt-connexion-template>
</template>

<script>
import MtConnexionTemplate from '~/components/connexion/connexion-template';
import MtPasswordSecurityMeter from '~/components/connexion/password-security-meter';
import MtModalOk from '~/components/modal/mt-modal-ok';
import passwordRulesMixin from '~/components/mixins/passwordRulesMixin';

export default {
  layout: 'simple',
  auth: false,
  components: {
    MtModalOk,
    MtConnexionTemplate,
    MtPasswordSecurityMeter,
  },
  mixins: [passwordRulesMixin],
  data() {
    return {
      ouvert: false,
      erreur: null,
    };
  },
  computed: {
    disablePage() {
      return (
        !this.user.password || !this.user.passwordconfirmation || this.user.password !== this.user.passwordconfirmation
      );
    },
  },
  async asyncData({ $api, params }) {
    const { token } = params;
    let errorToken;
    let user = {};
    try {
      user = await $api.utilisateurs.getChangementMotDePasse(params.token);
    } catch ({
      response: {
        status,
        data: { message },
      },
    }) {
      errorToken = { status, message };
    }
    return {
      errorToken,
      token,
      user,
    };
  },
  methods: {
    async valider() {
      try {
        if (this.user.password !== this.user.passwordconfirmation) {
          this.erreur = 'Les mots de passe doivent être identiques';
        } else {
          this.erreur = '';
          await this.$api.utilisateurs.postChangementMotDePasse(this.user);
          this.ouvert = true;
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    retourAccueil() {
      this.$router.push('/');
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.login h2 {
  padding-bottom: 0.7em;
}
.login .button {
  margin-top: 2rem;
}

.field.has-addons {
  display: block;

  /deep/ input {
    border-radius: 4px !important;
  }
}

/deep/ .column.field:not(:last-child) {
  margin-bottom: 0;
}
</style>
